package netprog.http;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


/**
 * Launcher of the HTTPServer
 * Provides logging
 * 
 * 
 * @author agapios
 *
 */
public class HTTPServerConsole extends JFrame{

	private JScrollPane jScrolPanel;
	private JPanel panel;
	private JTextArea jTextArea = new JTextArea();

	public HTTPServerConsole(int port, String wwwRoot) {
		try {
			initGui();
			HTTPServer server = new HTTPServer(port, this, wwwRoot);
			server.run();

		} catch(Exception e) {
			e.printStackTrace();
		}
	}


	/**
	 * Initializes all graphical components 
	 * 
	 * 
	 */
	private void initGui() {
		this.setTitle("Simple HTTP Server");
		
		jTextArea.setBackground(Color.black);
		jTextArea.setForeground(Color.yellow);
		jTextArea.setEditable(false);
		jTextArea.setColumns(60);
		jTextArea.setRows(30);
		jScrolPanel  = new JScrollPane();
		jScrolPanel.getViewport().add(jTextArea);

		jTextArea.validate();
		jScrolPanel.validate();
		this.add(jScrolPanel);


		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				closeHTTPServer();
			}
		});
		this.setSize(450, 350);
		this.setResizable(true);
		this.setVisible(true);
	}


	public void logInfo(String message) {
		jTextArea.append("INFO: " + message + " \n");
	}

	public void logError(String message) {
		jTextArea.append("ERROR: " + message + " \n");
		jTextArea.validate();
	}

	private void closeHTTPServer() {
		System.exit(0);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		HTTPServerConsole console = new HTTPServerConsole(1985, args[0]);

	}

}